SystemOrganization addCategory: #TusLibros!

Error subclass: #CanNotAddABookFromOtherEditorialToTheCart
	instanceVariableNames: 'book'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Error subclass: #CanNotCreateACashierWithAnEmptyCart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Error subclass: #CanNotCreateACashierWithAnExpiredCreditCard
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Error subclass: #CanNotCreateACreditCardWithAnInvalidName
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Error subclass: #CanNotCreateACreditCardWithAnInvalidNumber
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

Object subclass: #Cart
	instanceVariableNames: 'books cataloge'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:18'!
whichMustHaveBooksFrom: aCataloge 
	
	^ self new whichMustHaveBooksFrom: aCataloge ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:41'!
= aCart

	^ books = aCart books! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:26'!
add: aBook 

	(cataloge includes: aBook) ifFalse: [^ CanNotAddABookFromOtherEditorialToTheCart  signal].
	books add: aBook ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:41'!
books

	^ books! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:18'!
booksQuantity
	
	^ books size! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:18'!
initialize 
	
	books := Bag new.! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:19'!
isEmpty 

	^ books isEmpty ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:18'!
ocurrencesOf: aBook

	^ books occurrencesOf: aBook ! !

!Cart methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:18'!
whichMustHaveBooksFrom: aCataloge 
	
	cataloge := aCataloge ! !

Object subclass: #Cashier
	instanceVariableNames: 'cart creditCard'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cashier class methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:32'!
withCart: aCart andCreditCard: aCreditCard 
	
	(aCart isEmpty) ifTrue: [^ CanNotCreateACashierWithAnEmptyCart signal].
	(aCreditCard isExpired) ifTrue: [^ CanNotCreateACashierWithAnExpiredCreditCard signal].
	^ self new withCart: aCart andCreditCard: aCreditCard ! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:38'!
cart

	^ cart! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:41'!
creditCard

	^ creditCard! !

!Cashier methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:37'!
withCart: aCart andCreditCard: aCreditCard 
	
	cart := aCart .
	creditCard := aCreditCard .! !

Object subclass: #Cataloge
	instanceVariableNames: 'books'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cataloge class methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 11:20'!
withBooks: aSet 
	
	^ self new withBooks: aSet! !

!Cataloge methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 11:22'!
includes: aBook
	
	^ books includes: aBook ! !

!Cataloge methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 11:20'!
withBooks: aSet 
	
	books := aSet .! !

Object subclass: #CreditCard
	instanceVariableNames: 'number expirationDate owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!CreditCard class methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:03'!
withNumber: aNumber withExpirationDate: anExpirationDate propertyOf: anOwner 
	
	(aNumber isAllDigits and: aNumber size = 16) ifFalse: [^ CanNotCreateACreditCardWithAnInvalidNumber signal].
	(anOwner size > 3) ifFalse: [^ CanNotCreateACreditCardWithAnInvalidName signal].
	^ self new withNumber: aNumber withExpirationDate: anExpirationDate propertyOf: anOwner ! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:42'!
= aCreditCard 

	^ number = aCreditCard number and: (owner = aCreditCard owner and: expirationDate = aCreditCard expirationDate )! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:12'!
expirationDate

	^ expirationDate! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:41'!
isExpired
	
	^ Date today month > expirationDate ! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:11'!
number

	^ number! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 13:12'!
owner

	^ owner! !

!CreditCard methodsFor: 'as yet unclassified' stamp: 'TomasRodriguez 6/4/2013 12:41'!
withNumber: aLargePositiveInteger withExpirationDate: anExpirationDate propertyOf: anOwner 
	
	number := aLargePositiveInteger .
	expirationDate := anExpirationDate .
	owner := anOwner ! !

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTest methodsFor: 'books' stamp: 'TomasRodriguez 6/4/2013 11:10'!
bookFromEditorial
	
	^ 147896325! !

!TusLibrosTest methodsFor: 'books' stamp: 'TomasRodriguez 6/4/2013 10:39'!
bookFromOtherEditorial
	
	^ 9283478920
! !

!TusLibrosTest methodsFor: 'cart' stamp: 'TomasRodriguez 6/4/2013 12:29'!
cartWithBooks
	
	| cart |
	cart := self emptyCart .
	cart add: self bookFromEditorial.
	cart add: self otherBookFromEditorial .
	^ cart! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'TomasRodriguez 6/4/2013 12:27'!
cashierWithEmptyCart
	
	^ Cashier withCart: self emptyCart andCreditCard: ''! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'TomasRodriguez 6/4/2013 12:28'!
cashierWithExpiredCreditCard
	
	^ Cashier withCart: self cartWithBooks andCreditCard: self expiredCreditCard! !

!TusLibrosTest methodsFor: 'catalogue' stamp: 'TomasRodriguez 6/4/2013 11:19'!
cataloge
	
	| aSet |
	aSet := Set new.
	aSet add: 147896325.
	aSet add: 369874125.
	aSet add: 9874563210.
	aSet add: 172839465.
	^ Cataloge withBooks: aSet.! !

!TusLibrosTest methodsFor: 'cart' stamp: 'TomasRodriguez 6/4/2013 13:40'!
emptyCart
	
	| aCataloge |
	aCataloge := self cataloge.
	^ Cart whichMustHaveBooksFrom: aCataloge! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'TomasRodriguez 6/4/2013 12:51'!
expiredCreditCard
	
	| expiredDate |
	expiredDate := Date today month previous previous .
	^ CreditCard withNumber: '9600000000000000' withExpirationDate: expiredDate propertyOf: 'Inspector Archundia'! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'TomasRodriguez 6/4/2013 13:06'!
invalidNameCreditCard 

	^ CreditCard withNumber: '2854125469753125' withExpirationDate: (Date today month) propertyOf: 'A'! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'TomasRodriguez 6/4/2013 13:04'!
invalidNumberCreditCard 

	^ CreditCard withNumber: '2' withExpirationDate: (Date today month) propertyOf: 'Carlos Falso'! !

!TusLibrosTest methodsFor: 'books' stamp: 'TomasRodriguez 6/4/2013 11:32'!
otherBookFromEditorial
	
	^ 369874125! !

!TusLibrosTest methodsFor: '1 - Test Cart' stamp: 'TomasRodriguez 6/4/2013 11:49'!
test01CartShouldBeEmptyWhenCreated 

	self assert: self emptyCart isEmpty .! !

!TusLibrosTest methodsFor: '1 - Test Cart' stamp: 'TomasRodriguez 6/4/2013 11:49'!
test02AddingABookFromOtherEditorialShouldRaiseCanNotAddABookFromOtherEditorialToTheCartException

	| cart book |
	cart := self emptyCart.
	book := self bookFromOtherEditorial.
	
	[cart add: book.
	self fail] on: Error do: [ :anError |
			self assert: cart isEmpty .
			self assert: anError class = CanNotAddABookFromOtherEditorialToTheCart ]! !

!TusLibrosTest methodsFor: '1 - Test Cart' stamp: 'TomasRodriguez 6/4/2013 11:49'!
test03AddingABookFromTheEditorialShouldAddItToTheCart

	| aCart aBook |
	aCart := self emptyCart.
	aBook := self bookFromEditorial.
	aCart add: aBook.
	
	self deny: aCart isEmpty .
	self assert: (aCart ocurrencesOf: aBook) = 1.
	self assert: aCart booksQuantity = 1! !

!TusLibrosTest methodsFor: '1 - Test Cart' stamp: 'TomasRodriguez 6/4/2013 11:49'!
test04AddingABookFromTheEditorialTwiceShouldAddItToTheCartTwoTimes

	| aCart aBook |
	aCart := self emptyCart.
	aBook := self bookFromEditorial.
	aCart add: aBook.
	aCart add: aBook.
	
	self deny: aCart isEmpty .
	self assert: (aCart ocurrencesOf: aBook) = 2.
	self assert: aCart booksQuantity = 2! !

!TusLibrosTest methodsFor: '1 - Test Cart' stamp: 'TomasRodriguez 6/4/2013 11:49'!
test05AddingTwoDifferentBooksShouldAddBothBooksToTheCart

	| aCart aBook otherBook |
	aCart := self emptyCart.
	aBook := self bookFromEditorial.
	otherBook := self otherBookFromEditorial.
	aCart add: aBook.
	aCart add: otherBook.
	
	self deny: aCart isEmpty .
	self assert: (aCart ocurrencesOf: aBook) = 1.
	self assert: (aCart ocurrencesOf: otherBook) = 1.
	self assert: aCart booksQuantity = 2! !

!TusLibrosTest methodsFor: '2 - Test CreditCard' stamp: 'TomasRodriguez 6/4/2013 13:07'!
test06CreatingACreditCardWithAnInvalidNumberShouldRaiseCanNotCreateACreditCardWithAnInvalidNumberException 

	self should: [self invalidNumberCreditCard  ] raise: CanNotCreateACreditCardWithAnInvalidNumber! !

!TusLibrosTest methodsFor: '2 - Test CreditCard' stamp: 'TomasRodriguez 6/4/2013 13:06'!
test07CreatingACreditCardWithAnInvalidNameShouldRaiseCanNotCreateACreditCardWithAnInvalidNameException 

	self should: [self invalidNameCreditCard ] raise: CanNotCreateACreditCardWithAnInvalidName ! !

!TusLibrosTest methodsFor: '2 - Test CreditCard' stamp: 'TomasRodriguez 6/4/2013 13:12'!
test08AValidCreditCardCanBeCreated

	| number date owner creditCard |
	
	number := '7854236501495723'.
	date := Date today next next.
	owner := 'Juanito Mouse'.
	creditCard := CreditCard withNumber: number withExpirationDate: date propertyOf: owner.
	
	self assert: creditCard number = number.
	self assert: creditCard expirationDate = date.
	self assert: creditCard owner = owner 
	! !

!TusLibrosTest methodsFor: '3 - Test Cashier' stamp: 'TomasRodriguez 6/4/2013 13:13'!
test09CreatingACashierWithAnEmptyCartShouldRaiseCanNotCreateACashierWithAnEmptyCartException

	self should: [self cashierWithEmptyCart ] raise: CanNotCreateACashierWithAnEmptyCart! !

!TusLibrosTest methodsFor: '3 - Test Cashier' stamp: 'TomasRodriguez 6/4/2013 13:13'!
test10CreatingACashierWithAnExpiredCreditCardShouldRaiseCanNotCreateACashierWithAnExpiredCreditCardException

	self should: [self cashierWithExpiredCreditCard ] raise: CanNotCreateACashierWithAnExpiredCreditCard! !

!TusLibrosTest methodsFor: '3 - Test Cashier' stamp: 'TomasRodriguez 6/4/2013 13:43'!
test11ACashierWithACartWithBooksAndAValidCreditCardCanBeCreated

	| cashier |
	cashier := Cashier withCart: self cartWithBooks andCreditCard: self validCreditCard .
	
	self assert: cashier cart = self cartWithBooks .
	self assert: cashier creditCard = self validCreditCard! !

!TusLibrosTest methodsFor: 'cashier' stamp: 'TomasRodriguez 6/4/2013 13:44'!
validCashier

	^ Cashier withCart: self cartWithBooks  andCreditCard: self validCreditCard ! !

!TusLibrosTest methodsFor: 'credit card' stamp: 'TomasRodriguez 6/4/2013 13:07'!
validCreditCard
	
	| expiredDate |
	expiredDate := Date today month next next .
	^ CreditCard withNumber: '9600000000000000' withExpirationDate: expiredDate propertyOf: 'Inspector Archundia'! !
